=== dist/debian/debian/changelog ===
quick-lint-js (2.3.0-1) unstable; urgency=medium

  * New release.

 -- Matthew "strager" Glazar <strager.nds@gmail.com>  Thu, 24 Feb 2022 19:38:31 -0800

quick-lint-js (2.2.0-1) unstable; urgency=medium

  * New release.

 -- Matthew "strager" Glazar <strager.nds@gmail.com>  Thu, 17 Feb 2022 20:56:04 -0800

quick-lint-js (2.1.0-1) unstable; urgency=medium

  * New release.

 -- Matthew "strager" Glazar <strager.nds@gmail.com>  Wed, 09 Feb 2022 14:57:29 -0800

quick-lint-js (2.0.0-1) unstable; urgency=medium

  * New release.

 -- Matthew "strager" Glazar <strager.nds@gmail.com>  Tue, 08 Feb 2022 16:53:45 -0800

quick-lint-js (1.0.0-1) unstable; urgency=medium

  * New release.

 -- Matthew "strager" Glazar <strager.nds@gmail.com>  Mon, 13 Dec 2021 19:33:18 -0800

quick-lint-js (0.7.1-1) unstable; urgency=medium

  * New beta release.

 -- Matthew "strager" Glazar <strager.nds@gmail.com>  Mon, 06 Dec 2021 21:25:21 -0800

quick-lint-js (0.7.0-1) unstable; urgency=medium

  * New beta release.

 -- Matthew "strager" Glazar <strager.nds@gmail.com>  Sun, 05 Dec 2021 15:30:51 -0800

quick-lint-js (0.6.0-1) unstable; urgency=medium

  * New beta release.

 -- Matthew "strager" Glazar <strager.nds@gmail.com>  Sat, 20 Nov 2021 16:32:38 -0700

quick-lint-js (0.5.0-1) unstable; urgency=medium

  * New beta release.

 -- Matthew "strager" Glazar <strager.nds@gmail.com>  Tue, 12 Oct 2021 20:57:21 -0700

quick-lint-js (0.4.0-1) unstable; urgency=medium

  * New beta release.

 -- Matthew "strager" Glazar <strager.nds@gmail.com>  Thu, 09 Sep 2021 09:04:53 -0700

quick-lint-js (0.3.0-1) unstable; urgency=medium

  * New beta release.

 -- Matthew "strager" Glazar <strager.nds@gmail.com>  Fri, 02 Jul 2021 19:20:46 -0700

quick-lint-js (0.2.0-1) unstable; urgency=medium

  * New beta release.

 -- Matthew "strager" Glazar <strager.nds@gmail.com>  Mon, 05 Apr 2021 19:28:08 -0700

quick-lint-js (0.1.0-1) unstable; urgency=medium

  * Initial release.

 -- Matthew "strager" Glazar <strager.nds@gmail.com>  Thu, 14 Jan 2021 19:25:47 -0800
