=== dist/debian/debian/rules ===
#!/usr/bin/make -f

export CC = gcc-9
export CXX = g++-9

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ --parallel

override_dh_auto_configure:
	dh_auto_configure -- -DQUICK_LINT_JS_INSTALL_VIM_DIR=share/vim/addons -DQUICK_LINT_JS_INSTALL_VIM_NEOVIM_TAGS=ON

override_dh_auto_install:
	dh_auto_install
	install -m644 -D plugin/vim/quick-lint-js.yaml debian/tmp/usr/share/vim/registry/quick-lint-js.yaml

override_dh_strip:
	dh_strip $@ --dbg-package=quick-lint-js-dbgsym
